from common_py.plotting import *
import polars as pl
import os

if __name__ == "__main__":
    df = (pl
        .scan_csv("../enem_aggregate/GENERATED/localGen_result.csv")
        .collect()
    )

    print(df)
    PlotData(
        title="Interactions with ENEM questions",
        save_path=f"./{os.path.basename(__file__).split('.')[0]}.pdf",
        x_ax=AxData("#student interactions"),
        y_ax=AxData("#questions"),
        graphs=[
            Plot(xData=df["#total_answers"].to_list(), yData=df["qname"].to_list(), kwargs={"marker": "x", "linestyle": "None"}),
        ]
    ).create().draw_and_save()