from common_py.plotting import *
import polars as pl
import numpy as np
import os
import json

if __name__ == "__main__":
    df: pl.DataFrame = (
        pl.scan_csv("../raw_data/brasilian/official_data/2016/DADOS/MICRODADOS_ENEM_*.csv", separator=";", encoding="utf8-lossy")
        .head(n=8)
        .select([
            pl.col("NU_INSCRICAO"), 
            pl.lit("...").alias("[more rows]"),
            pl.col("^TX_RESPOSTAS_..$"),
            pl.lit("...").alias("[yet more rows]"),
        ])
        .collect()
    )
    df.write_csv(f"{os.path.basename(__file__).split('.')[0]}.csv")
    print(df)