from common_py.plotting import *
import polars as pl
import os

if __name__ == "__main__":
    df = pl.scan_csv("../enem_aggregate/GENERATED/localGen_result.csv").collect()
    # print(df.filter(pl.col("irt_b") > 10))
    plot = PlotData(
        title="IRT difficulty (INEP) vs correctness",
        save_path=f"./{os.path.basename(__file__).split('.')[0]}.pdf",
        x_ax=AxData("INEP IRT Difficulty", top=8),
        y_ax=AxData("Correctness (all participants)"),
        graphs=[
            Plot(xData=df["irt_b"].to_list(), yData=df["correctness"].to_list(), kwargs={"marker": "x", "linestyle": "None"}),
        ]
    ).create()
    plot.draw_and_save()