#!/bin/sh

LEGAL_EXEC_DIR='~/process_enem'

AUTHENTICATED_SSH_HOST="uniClusterIp"

cargo build --target x86_64-unknown-linux-gnu --release --bin cluster

ssh ${AUTHENTICATED_SSH_HOST} "mkdir -p ${LEGAL_EXEC_DIR}"

scp target/x86_64-unknown-linux-gnu/release/cluster slurm.sh ${AUTHENTICATED_SSH_HOST}:${LEGAL_EXEC_DIR}/

# TODO: revisit once the global project structure is established. 
# compress and send over data.
# I strongly suggest compression to move the data,
# as that slimmed down the filesize from 40 GB to 8 GB for me (text files auch as csv are easy to compress).
# comment this out if the data is already there.
tar cafv official_data.tar.zst ../raw_data/enem/official_data/**/*.csv
scp official_data.tar.zst ${AUTHENTICATED_SSH_HOST}:${LEGAL_EXEC_DIR}/

ssh ${AUTHENTICATED_SSH_HOST} <<EOF_SSH
set -o errexit

cd ${LEGAL_EXEC_DIR}
# you may also comment this and the following line out if its not required.
enroot import docker://ubuntu
enroot create ubuntu
tar xvaf official_data.tar.zst
sbatch slurm.sh
exit
EOF_SSH