#!/bin/sh

set -o errexit

set -o xtrace

# Hardcoded directory path.
# ensure this doesnt get run in the wrong directory, otherwise it could fuck up my repos
target_directory="/home/smaier/workspace/hft/BA/meta/monorepo"

if [ "$(pwd)" != "$target_directory" ]; then
    echo "Execution directory is not equal to the target directory."
    exit 1
fi

# old code that recreated the repository each time
# "remove" old repo
# rm -rf .git

cd ../..

# my filesystem is btrfs. Its a copy on write (COW) filesystem. 
# Because of that it copies the 50GB of enem raw data just like that, glorious thing.
# If your filesystem doesnt use COW (NTFS, fat - both windows - and ext4 - more usual Linux FS - do not, I dunno about apple) 
# then this may be slow, and you may want to look for an alternative.
cp -r common_py data_explore enem_aggregate moodle_extract qde_model_code raw_data meta/monorepo

cd meta/monorepo || exit

# "remove" the individual repositories, otherwise git wants to make them submodules.
rm -rf ./**/.git

# old code that recreated the repository each time
# git init --initial-branch=main

git add .

git commit -m "Update snapshot"

# old code that recreated the repository each time
# git remote add old_origin ssh://git@gitlab.rz.hft-stuttgart.de:54321/02masa1bif/pretrained_qde_closed_q.git
# git remote add origin ssh://git@transfer.hft-stuttgart.de:22/samuel.maier2/pretrained_qde_closed_q.git
# git remote add origin2 ssh://git@gitea.smaier.me:222/BA/monorepo.git

set +o xtrace

printf "\n\nNow push up with:\n"

echo 'git push'
# old code that recreated the repository each time
# echo 'git push --force --set-upstream origin main'