# Parsing HFT Questions and mapping them to a more generic format

This contains code that parses the generated Moodle question XMLs and then maps them to Python data classes ([data classes with parts of the xml parsing](./moodle_questions_dataclasses.py), [the code that uses these data classes and parses a file](./extract_moodle_xml.py)).

Then other code in here takes those dataclasses and maps them to a more generic format.
Data loss is inevitable in this step, so it is separated to be able to iterate.
[This is the code](./moodle_to_generic_questions.py)

Then, because I do not want to run this stuff on the cluster (that would be a nightmare), these questions end up in a csv file along with the experimental information.
The mapping of questions to strings (csv does not support nested data, questions have answers -> nesting) is done in [this file](./map_generic_question_to_str.py).
Note that during the simplification when mapping to the generic format, answers to some questions are already mapped to strings as part of the simplification (e.g. "choose the right word here" type questions).
Reading the experimental data and writing the csv [happens here](./combine_hft_data.py).

# Installation

See Top-Level [README](../README.md)