"""
This file contains fairly simple logic that converts generic
questions to answers as they were found in the enem dataset.
"""
from common_py.string_processing import cleanHtml, stripLines, combineStrIter
from moodle_to_generic_questions import GenericQuestion, AnswerOption

def mapGenericQuestionToAnswerStr(input: GenericQuestion):
    return stripLines(combineStrIter([f"#{'T' if ans['correct'] else 'F'} {cleanHtml(ans['text'])}" for ans in input.answerOptions]))

def mapGenericQuestionToQuestionStr(input: GenericQuestion):
    return stripLines(cleanHtml(input.questionText))

def mapGenericQuestionToStr(input: GenericQuestion):
    return f"{mapGenericQuestionToQuestionStr(input)}{mapGenericQuestionToAnswerStr(input)}"

if __name__=="__main__":
    print(
        mapGenericQuestionToStr(GenericQuestion("alaaa", "<h>headertext</h>", [AnswerOption(text="Answertext", correct=False)], "whatever"))
    )