"TODO: Not a plot, not the right file"

import numpy as np
import polars as pl
from typing import NamedTuple
from numpy import typing as npt
from common_py.plotting import *
from common_py.utils import Statistics
import re
import os
import json

if __name__ == '__main__':
    analyzedDir = "./results/containerbased_hftv15"

    varied_variable = "seed"
    varied_variable_pretty = varied_variable

    correlation_coefficient: list[float] = []
    rmse: list[float] = []
    varied_variable_vals = []

    for modelConfigIdentifier in [
        match.group(1) 
        for match
        in [
            re.match(r"(hash\[[\d\w-]*\])_config.json", fileName)
            for fileName
            in os.listdir(analyzedDir)
        ]
        if match
    ]:
        basePath = f"{analyzedDir}/{modelConfigIdentifier}"
        with open(f"{basePath}_config.json") as fp:
            config = json.load(fp)
        history = pl.read_csv(f"{basePath}_history.csv")

        target = config["target"]

        varied_variable_vals.append(config[varied_variable])

        target_sqErr_col = f"{target}_err_squared"
        target_absErr_col = f"{target}_err_abs"

        predictions: pl.DataFrame = (pl.read_csv(f"{basePath}_predictions.csv", dtypes={"split": pl.Categorical})
            .with_columns(
            (pl.col(target) - pl.col(f"predicted_{target}")).abs()
                .alias(target_absErr_col),
            (pl.col(target) - pl.col(f"predicted_{target}")).pow(2)
                .alias(target_sqErr_col)
            )
        )
        stat_sqErr = Statistics.from_numpy(predictions[target_sqErr_col].to_numpy())
        rmse.append(
            np.sqrt(stat_sqErr.mean)
        )
        correlation_coefficient.append(
            np.corrcoef(predictions[target].to_numpy(), predictions[f"predicted_{target}"].to_numpy())[0,1]
        )

    PlotData(
        [
            Plot(correlation_coefficient, varied_variable_vals, kind="scatter", label="correlation over levt out data points"),
        ],
        x_ax=AxData(varied_variable_pretty),
        y_ax=AxData("Linear correlation coefficient"),
        save_path=f"{analyzedDir}/correlation_variance.pdf",
    ).create().draw_and_save()