"have fun trying to understand the choices in here, i dont have time to document it properly"

import numpy as np
import polars as pl
from typing import NamedTuple
from numpy import typing as npt
from common_py.plotting import *
from common_py.utils import Statistics
import re
import os
import json
import math

if __name__ == '__main__':
    analyzedTopDir = "./results/clean"

    configIdents: list[str] = []
    configPaths: list[str] = []
    configStr: list[str] = []
    valid_correlation_coefficient: list[float] = []
    train_correlation_coefficient: list[float] = []
    test_correlation_coefficient: list[float] = []
    combined_correlation_coefficient: list[float] = []

    for (path, _, filenames) in os.walk(analyzedTopDir):
        for modelConfigIdentifier in [
            match.group(1) 
            for match
            in [
                re.match(r"(hash\[[\d\w-]*\])_config.json", fileName)
                for fileName
                in filenames
            ]
            if match
        ]:
            try:
                basePath = f"{path}/{modelConfigIdentifier}"
                # kindof problematic but for now it works
                if "hft" in basePath:
                    continue

                with open(f"{basePath}_config.json") as fp:
                    config = json.load(fp)
                history = pl.read_csv(f"{basePath}_history.csv")

                target = config["target"]

                target_sqErr_col = f"{target}_err_squared"
                target_absErr_col = f"{target}_err_abs"

                predictions: pl.DataFrame = (pl.read_csv(f"{basePath}_predictions.csv", dtypes={"split": pl.Categorical})
                    .with_columns(
                    (pl.col(target) - pl.col(f"predicted_{target}")).abs()
                        .alias(target_absErr_col),
                    (pl.col(target) - pl.col(f"predicted_{target}")).pow(2)
                        .alias(target_sqErr_col)
                    )
                )
                predictions_valid: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "validate")
                )
                predictions_train: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "train")
                )
                predictions_test: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "test")
                )
                valid_correlation_coeff_val = np.corrcoef(predictions_valid[target].to_numpy(), predictions_valid[f"predicted_{target}"].to_numpy())[0,1]
                train_correlation_coeff_val = np.corrcoef(predictions_train[target].to_numpy(), predictions_train[f"predicted_{target}"].to_numpy())[0,1]
                test_correlation_coeff_val = np.corrcoef(predictions_test[target].to_numpy(), predictions_test[f"predicted_{target}"].to_numpy())[0,1]
                combined_correlation_coeff_val = math.pow(valid_correlation_coeff_val * valid_correlation_coeff_val * train_correlation_coeff_val, 1.0/3)
                # combined_correlation_coeff_val = (2 * valid_correlation_coeff_val + train_correlation_coeff_val) / 3
                
                # any of the above operations might fail, for a multitude of reasons but usually this indicates problematic data
                # (eg when the pipeline stopped early, leading to "missing" exected files) or at the very least not a good result
                # (eg a non-convergence that is largely flat, but actually results in a negative correlation, which in turn leads to errors when doing a root during geometric mean calculation), 
                # so we just skip it.
                # But because of that I moved all the append operations to the end, so we dont include partial data, which would lead to us combining the wrong values
                configPaths.append(basePath)
                configIdents.append(modelConfigIdentifier)
                configStr.append(str(config))
                valid_correlation_coefficient.append(
                    valid_correlation_coeff_val
                )
                train_correlation_coefficient.append(
                    train_correlation_coeff_val
                )
                combined_correlation_coefficient.append(
                    combined_correlation_coeff_val
                )
                test_correlation_coefficient.append(
                    test_correlation_coeff_val
                )
            except Exception as ex:
                print(ex)
                continue

    df = pl.DataFrame({
        "combined_corr_coeff": pl.Series(combined_correlation_coefficient),
        "valid_corr_coeff": pl.Series(valid_correlation_coefficient),
        "train_corr_coeff": pl.Series(train_correlation_coefficient),
        "test_corr_coeff": pl.Series(test_correlation_coefficient),
        "ident": pl.Series(configIdents),
        "paths": pl.Series(configPaths),
        "config": pl.Series(configStr),
    })

    correlation_correlation = np.corrcoef(df["valid_corr_coeff"], df["train_corr_coeff"])[0,1]
    ";-)"

    print(f"correlation of training vs validation coefficient: {correlation_correlation}")

    df: pl.DataFrame = df.sort("test_corr_coeff", descending=True)

    print(df.head())
    print(df.tail())

    df.write_csv(f"{analyzedTopDir}/ranked.csv")
