"have fun trying to understand the choices in here, i dont have time to document it properly"

import numpy as np
import polars as pl
from typing import NamedTuple
from numpy import typing as npt
from common_py.plotting import *
from common_py.utils import Statistics
import re
import os
import json
import math
import traceback

if __name__ == '__main__':
    analyzedTopDir = "./results/clean"

    batch_size = 16

    varied = [
        "learning_rate",
        "dropout_pretrained",
        "dropout_regression",
        "batch_size",
    ]
    "the parameter in the training section of the config, that were actually varied."

    basis_params = {
        # "learning_rate": 0.0001,
        "dropout_pretrained": 0.0,
        "dropout_regression": 0.1,
        "batch_size": batch_size,
        "earlystop_patience": 10,
    }
    """
    This contains the settings that form the basis for the comparisons.

    They should be found in the training section of the config.

    A single param from `varied` should miss here, 
    this will be the one where variations will be plotted.

    Additional params may be added here.
    These will also be checked, and if a config doesnt have these values it'll also be skipped.
    """

    configIdents: list[str] = []
    configPaths: list[str] = []
    configStr: list[str] = []
    valid_correlation_coefficient: list[float] = []
    train_correlation_coefficient: list[float] = []
    test_correlation_coefficient: list[float] = []
    combined_correlation_coefficient: list[float] = []
    varied_param_vals = []

    varied_param = []

    for param in varied:
        # .get doesnt raise an exception, but returns None if the dict doesnt contains this field.
        if basis_params.get(param) is None:
            varied_param.append(param)

    if not len(varied_param) == 1:
        raise Exception("script config is wrong. Please read the attached pydoc")

    varied_param = varied_param[0]

    for (path, _, filenames) in os.walk(analyzedTopDir):
        for modelConfigIdentifier in [
            match.group(1) 
            for match
            in [
                re.match(r"(hash\[[\d\w-]*\])_config.json", fileName)
                for fileName
                in filenames
            ]
            if match
        ]:
            try:
                basePath = f"{path}/{modelConfigIdentifier}"
                # kindof problematic but for now it works
                if "hft" in basePath:
                    continue

                with open(f"{basePath}_config.json") as fp:
                    config = json.load(fp)

                train_conf = config["training"]

                continue_outer = False

                for param in basis_params:
                    if train_conf[param] != basis_params[param]:
                        continue_outer = True
                        break

                if continue_outer:
                    continue

                print(basePath)

                varied_param_val = train_conf[varied_param]

                history = pl.read_csv(f"{basePath}_history.csv")

                target = config["target"]

                target_sqErr_col = f"{target}_err_squared"
                target_absErr_col = f"{target}_err_abs"

                predictions: pl.DataFrame = (pl.read_csv(f"{basePath}_predictions.csv", dtypes={"split": pl.Categorical})
                    .with_columns(
                    (pl.col(target) - pl.col(f"predicted_{target}")).abs()
                        .alias(target_absErr_col),
                    (pl.col(target) - pl.col(f"predicted_{target}")).pow(2)
                        .alias(target_sqErr_col)
                    )
                )
                predictions_valid: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "validate")
                )
                predictions_train: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "train")
                )
                predictions_test: pl.DataFrame = (predictions
                    .filter(pl.col("split") == "test")
                )
                valid_correlation_coeff_val = np.corrcoef(predictions_valid[target].to_numpy(), predictions_valid[f"predicted_{target}"].to_numpy())[0,1]
                train_correlation_coeff_val = np.corrcoef(predictions_train[target].to_numpy(), predictions_train[f"predicted_{target}"].to_numpy())[0,1]
                test_correlation_coeff_val = np.corrcoef(predictions_test[target].to_numpy(), predictions_test[f"predicted_{target}"].to_numpy())[0,1]
                combined_correlation_coeff_val = math.pow(valid_correlation_coeff_val * valid_correlation_coeff_val * train_correlation_coeff_val, 1.0/3)
                # combined_correlation_coeff_val = (2 * valid_correlation_coeff_val + train_correlation_coeff_val) / 3
                
                # any of the above operations might fail, for a multitude of reasons but usually this indicates problematic data
                # (eg when the pipeline stopped early, leading to "missing" exected files) or at the very least not a good result
                # (eg a non-convergence that is largely flat, but actually results in a negative correlation, which in turn leads to errors when doing a root during geometric mean calculation), 
                # so we just skip it.
                # But because of that I moved all the append operations to the end, so we dont include partial data, which would lead to us combining the wrong values
                configPaths.append(basePath)
                configIdents.append(modelConfigIdentifier)
                configStr.append(str(config))
                varied_param_vals.append(varied_param_val)
                valid_correlation_coefficient.append(
                    valid_correlation_coeff_val
                )
                train_correlation_coefficient.append(
                    train_correlation_coeff_val
                )
                combined_correlation_coefficient.append(
                    combined_correlation_coeff_val
                )
                test_correlation_coefficient.append(
                    test_correlation_coeff_val
                )
            except Exception as ex:
                print(ex)
                # traceback.print_exc()
                continue

    PlotData(
        x_ax=AxData(label=varied_param),
        y_ax=AxData(label='correlation coefficient'),
        save_path=f"{analyzedTopDir}/bs_{batch_size}_varied_{varied_param}.pdf",
        graphs=[
            Plot(yData=train_correlation_coefficient, xData=varied_param_vals, label="training", kind="scatter"),
            Plot(yData=valid_correlation_coefficient, xData=varied_param_vals, label="validation", kind="scatter"),
            # Plot(yData=combined_correlation_coefficient, xData=varied_param_vals, label="combined", kind="scatter"),
        ]
    ).create().draw_and_save()