# Official microdados enem data

Data taken from https://www.gov.br/inep/pt-br/acesso-a-informacao/dados-abertos/microdados/enem

Simply extracted in this directory, renaming the folder.

Data is not here purely for size concerns.
Its about 50 GB.

## Years aggregated

The aggregation was done on the years $[2009, 2021] \cap \mathbb{N}$.
In 2022 questions were repeated in ENEM, so it provides no new data.

Files outside of this range may have inconsistencies that were not considered.
Some of the tests in the [aggregation code](../../../enem_aggregate/) were removed afterwards, and other tests were only done manually.
So adding new years might cause the aggretation to fail and in anycase should be done with care, to not falsify the data.

## Specific source files

### `[YEAR]/DADOS/ITENS_PROVA_[YEAR].csv` (`ITENS_PROVA`)

Contains metainfo to the questions

Uses different separators!

### `[YEAR]/DADOS/MICRODADOS_ENEM_[YEAR].csv` (`MICRODADOS_ENEM`)

Contains interactions of students (with all questions of one topic in one entry, eg `NU_NOTA_[TOPIC]`).

Again inconsistent separators!

### `[YEAR]/DICIONÁRIO/Dicionário_Microdados_Enem_[YEAR].xlsx`(`dictionary`)

Contains further meta info, among others the correlation of the numbers in `MICRODADOS_ENEM/CO_PROVA_[TOPIC]` to the color of the students exam, which determined the order of the questions.
